

C     PROGRAM NODC2DATA
C
C     FOR AN EASY LOOK AT HYDRO DATA IN LIST FORMAT
C     INPUT:  80 COLUMN NODC CARD IMAGE HYDRO DATA -
C              ONLY D,T,S FIELDS ARE READ
C     OUTPUT:  HYDRO DATA LISTING BY STATION.  
C
C              
C              
C
C     FIRST VERSION  1  MODIFIED VERSION OF SBREAD WHICH IS A MODIFIED
C     17/03/90          VERSION OF 'UNWRAP' BY D. PATANJO
C
c     Dec 8,1995 Jim Manning made modification of nodc2mtl to output ".data" form
c                for standard "oax" input"
c
C ****************************************************************
C
        CHARACTER *80 IBUFF,BLANK*5,SHIP*2,P(5)*5,Q(5)*1,OP(5)*1,
     1  IFLAG*1,HEAD*60,MC(10),NC(10)
	integer temp(400),salt(400),depth(400)
	DIMENSION V(5),Z(3),INFILE(10),OUTFILE(10)
        DATA Z/0.01,0.001,0.01/
	DATA MC/' ','J','K','L','M','N','O','P','Q','R'/
	DATA NC/'0','1','2','3','4','5','6','7','8','9'/
        INTEGER COUNTRY,LAT,LONG,YEAR,MONTH,DAY,HOUR,PH,SI,NTA,NTI,CH,
     1 	RA,CRUISENO,STANO,BOTDEPTH,MMN,BDIFF
	character deg*1
        character*80 infile1,outfile1
        ideg=176
        deg=char(ideg)
        BLANK= '     '
        fudge=0.1

C
	TYPE *,'ENTER CRUISE FILE NAME'
        read(*,'(A)')infile1       
c	OPEN(UNIT=1,NAME='oc301.nodc',status='old',READONLY)
	OPEN(UNIT=1,NAME=infile1,status='old',READONLY)
C
	TYPE *,'ENTER OUTPUT FILE NAME (give it a .data extension)'
        read(*,'(A)')outfile1       
C
	OPEN(UNIT=2,FILE=outfile1,STATUS='UNKNOWN',CARRIAGECONTROL='FORTRAN',
     1  form='formatted')
c	WRITE(2,39)
c   39	FORMAT('1',//'  CON  FIX     POSITION        DATE    TIME     ',
c     1  'BTM      SURFACE    SFC SAMPLE     DEEPEST     DEEP SAMPLE',  
c     +  '  METERS FROM')
c	WRITE(2,36)
c   36	FORMAT('   #    #    LAT     LONG    DD/MM/YY  HH:MM   DEPTH   ',
c     1	'TEMP   SALT    DEPTH      TEMP   SALT     DEPTH       BOTTOM')
C
c	write(2,995)
c  995 	format('              N        W                GMT      M     ',
c     1  'DEG C   PSU      M        DEG C   PSU       M           M')
c	WRITE(2,38)
c   38	FORMAT('+',' ___  ___  ______  ______   ________  _____   ',
c     1  '_____   ____  ______   _____      _____  _____    _____',
c     1  '       ______'/)
   10	READ (1,'(A)',END=11)IBUFF
	DECODE (80,20,IBUFF)IFLAG
   20	FORMAT(79X,A1)
C
C     TEST FOR STATION HEADER AND WRITE HEADER DATA
   37	IF (IFLAG .EQ. '1')then
	DECODE (80,30,IBUFF)COUNTRY,SHIP,LAT,LONG,YEAR,
     1	MONTH,DAY,HOUR,CRUISENO,STANO,BOTDEPTH,MMN
   30	FORMAT(I2,A2,I5,1X,I5,3X,I2,I2,I2,I3,1X,I2,I3,I4,32X,I3)
	RLAT=LAT/10.
	RLON=LONG/10.
	RHOUR=HOUR/10.
	NHOUR=INT(RHOUR)
	RMIN=RHOUR-NHOUR
	NMIN=RMIN*60
	LINE=1
	else
	goto 10
	endif
C
   11	READ (1,'(A)',END=12)IBUFF
	DECODE (80,20,IBUFF)IFLAG
	k=1
   12	IF (IFLAG .EQ. '3') then
	DECODE(80,62,IBUFF) DEPTH(k),temp(k),salt(k)
   62	FORMAT(27X,I4,1X,i4,1X,i5)
	k=k+1
   63	READ (1,'(A)',END=98)IBUFF
	DECODE (80,20,IBUFF)IFLAG
	goto 12
	else
c
c convert to decimal degrees and make longitude negative
c
        call degdec(rlat)
        call degdec(rlon)
        rlon=rlon*(-1)
c
c write out this stations values
c
        do 411 jj=1,k-1
          dep=depth(jj)
          stem=temp(jj)/100.
          ssal=salt(jj)/1000.
          call julian(day,month,nhour,nmin,jd)
          call ll2xy(1,rlat,rlon,x,y)
          sigma=sigmat(stem,ssal)

          WRITE (2,410)x,y,dep,jd,stem,ssal,sigma,fudge,rlat,rlon,
     &stano,mmn
410       format(2f10.0,f6.0,4f9.3,f4.1,2f8.3,i4,i4)
411     continue
c
	DECODE (80,30,IBUFF)COUNTRY,SHIP,LAT,LONG,YEAR,MONTH,DAY,
     1  HOUR,CRUISENO,STANO,BOTDEPTH,MMN
	RLAT=LAT/10.
	RLON=LONG/10.
	RHOUR=HOUR/10.
	NHOUR=INT(RHOUR)
	RMIN=RHOUR-NHOUR
	NMIN=RMIN*60
	ENDIF
	goto 11
C
   98  continue
C
   99  	write(*,*)'look for .data file'
        STOP
	END
C
C      function SIGMAT
C
      FUNCTION SIGMAT(T,S)
      REAL*8 S0,E1,E2,B1,B2
	S0=((6.76786136E-6*S - 4.8249614E-4)*S+0.814876577)*S-
     C  0.0934458632
	E1=(((-1.4380306E-7*T-0.00198248399)*T-0.545939111)*T
     C  + 4.53168426)*T
	B1=((-1.0843E-6*T+9.8185E-5)*T-0.0047867)*T+1.
	B2=((1.667E-8*T-8.164E-7)*T+1.803E-5)*T
	E2=(B2*S0+B1)*S0
	SIGMAT=E1/(T+67.26) + E2
	RETURN
	END
c
        subroutine degdec(lat)
c
c this routine converts deg and minutes to decimal degrees
c
	real lat
	lat=lat/100.
	intlat=int(lat)
	declat=lat-intlat
	declat=(declat*100)/60.
	lat=intlat+declat
	return
	end



c subrouine to convert lat lon to x and y

      subroutine ll2xy(nopt,lat,long,x,y)
c
c variable declarations
c
      character*72 inname
      integer nopt
      real x,y,lat,long
c
c-----------------------------------------------------------------------
c the projection type is set by nopt:
c   nopt=1  =>  convert provided (dlong,dlat) to (x,y)
c   nopt=2  =>  convert provided (x,y) to (dlong,dlat)
c-----------------------------------------------------------------------
c
      if(nopt.eq.1) goto 333
      if(nopt.eq.2) goto 666
      goto 999
c
c NOPT = 1 & 2;  conversion from LO/LA to XY
c

333   call mercbos(nopt,long,lat,x,y)
      go to 1000
c
c NOPT = 2;  conversion from XY to LO/LA
c
666   call mercbos(nopt,long,lat,x,y)
      go to 1000

 999  print*,'ILLEGAL OPTION'
 1000  return
       end 
c     
c ============================================================
c
c ======== routines for mercator projection ==================
c
c ============================================================
c
c*****67****************************************************************
c***********************************************************************
c subroutine mercbos
c christopher e. naimie
c dartmouth college - 25 nov 1991
c
c this subroutine performs a mercator projection, using 
c   boston, ma., usa as the (x,y) origin.
c 
c units: dlong is the longitude in degrees, positive east of grenwich.
c        dlat is the latitude in degrees, positive north of the equator.
c        x and y are in mks units.
c
c the constants used are:
c      longitude at boston = -71.03 deg e
c      latitude at boston  =  42.35 deg n
c      radius of the earth =  6.3675e+6 meters 
c
c the projection type is set by nopt:
c   nopt=1  =>  convert provided (dlong,dlat) to (x,y)
c   nopt=2  =>  convert provided (x,y) to (dlong,dlat)
c-----------------------------------------------------------------------
      subroutine mercbos(nopt,dlong,dlat,x,y)
c set constants and (xo,yo) coordinates of boston during initial call. 
	if(kkk.NE.64)then
         r=6.3675e+6                            
         reflong=rad(-71.03)                    
         reflat=rad(42.35)                      
         xo=r*cos(reflat)*reflong
         yo=r*cos(reflat)*alog((1.0+sin(reflat))/cos(reflat))
   	   kkk=64
	endif
c if nopt=1:  convert (dlong,dlat) to (x,y) and subtract (xo,yo)
      if(nopt.eq.1)then
         rlong=rad(dlong)              
         rlat=rad(dlat)
         x=r*cos(reflat)*rlong-xo
         y=r*cos(reflat)*alog((1.0+sin(rlat))/cos(rlat))-yo      
         return
c if nopt=2:  convert (x+xo,y+xo) to (long,lat)
      else if(nopt.eq.2)then
         rlong=(x+xo)/(r*cos(reflat))
         call newtlat(rlat,y+yo,reflat,r)
         dlong=deg(rlong)
         dlat=deg(rlat)
         return
      else
         write(*,*)'subroutine mercbos requires nopt be set 1 or 2.'
         stop
      endif
	end     
c*****67****************************************************************
c***********************************************************************
c subroutine newtlat
c christopher e. naimie
c dartmouth college - 25 nov 1991
c
c this subroutine uses the newton-raphson method to calculate the 
c   latitude (in radians), given the following information:
c      r=radius of the earth (m)
c      y=y coordinate of the point who's latitude is desired (m/sec)
c      reflat=reference latitude where y is zero (radians)
c the latitude at y is returned as rlat (in radians).
c-----------------------------------------------------------------------
      subroutine newtlat(rlat,y,reflat,r)
c set constants
      tol=0.0001
      n=1000
c  enter iteration loop
      po=reflat
      do 10 i=1,n
         p1=po-((1.0+sin(po))/cos(po)-exp(y/(r*cos(reflat))))
     &         /((1.0+sin(po))/((cos(po))**2.0))
         if(abs(p1-po).lt.tol)then
           rlat=p1
           return
         endif
         po=p1
 10   continue
c
c  if loop has completed, the method failed.
c
      write(*,*)' a root was not found after ',n,' iterations.'
      return
      end
c****67****************************************************************
c****67****************************************************************
c convert degrees to radians
      real function rad(degrees)
      pi=3.14159265359
      rad=degrees*pi/180.0
      return
      end
c*****67****************************************************************
c***********************************************************************
c convert radians to degrees
      real function deg(radians)
      pi=3.14159265359
      deg=radians*180.0/pi
      return
      end
c*****67****************************************************************
c***********************************************************************

      SUBROUTINE Julian(D,M,hr,mn,jd)
C     ************************************************************
C**   WHERE...
C        D.... DAY (1-31) COMPONENT OF GREGORIAN DATE
C        M.... MONTH (1-12) COMPONENT
C        Y.... YEAR (E.G., 1979) COMPONENT
c*************
c WARNING: THIS VERSION DOES NOT CORRECT FOR LEAP YEAR!!!!!!!!!!!
C*************
C        J.... CORRESPONDING JULIAN DAY NUMBER
C     ************************************************************
      INTEGER*4 mth(12)
      INTEGER*4 D,M,hr,mn
      REAL jd,frac,frac2
C
      mth(1)=0
      mth(2)=31
      mth(3)=59
      mth(4)=90
      mth(5)=120
      mth(6)=151
      mth(7)=181
      mth(8)=212
      mth(9)=243
      mth(10)=273
      mth(11)=304
      mth(12)=334
    
      frac=hr*100.0+(mn/60.0*100.0)
      frac2=frac/2400.0

      jd=mth(M)+d-1+frac2
    
     
      RETURN
      END
