CC Program  ENDCRUIS.FOR
CC
CC MODIFIED VERSION OF tynodc.FOR TO READ IN EXISTING HEADERS
CC
CC Make jgof *.h3 files (the .h1 and .h2 files aren't as
CC hard as the .h3) at end of each bscale cruise
CC and to make an output NODC file of the MK5 data including FL
CC if desired.  
CC
CC You may want to make sure that your input header 
CC file is correctly named...brscale.hdr  
CC
CC This program does not have to be run at sea but can be run 
CC hopefully w/in a week after the cruise
CC
CC
CC *** JUNE 1996, Modified by M. Taylor to change the calculation of
CC     sigma-t to UNESCO 1983 pg. 17 Fofonoff and Millard
CC
CC
CC************* DEFINE VARIABLES
      FUNCTION SIGMA(T,S)
      dimension a(6),b(5),c(3)
      REAL*8 pw,bval,cval,d0,a,b,c
c
      a(1)=999.842594
      a(2)=6.793952e-2
      a(3)=-9.095290e-3
      a(4)=1.001685e-4
      a(5)=-1.120083e-6
      a(6)=6.536332e-9
      pw=a(1)+(a(2)*t)+(a(3)*(t**2))+(a(4)*(t**3))+(a(5)*(t**4))+
     +  (a(6)*(t**5))
      b(1)=8.24493e-1
      b(2)=-4.0899e-3
      b(3)=7.6438e-5
      b(4)=-8.2467e-7
      b(5)=5.3875e-9
      bval=(b(1)+(b(2)*t)+(b(3)*(t**2))+(b(4)*(t**3))+(b(5)*(t**4)))*s
      c(1)=-5.72466e-3
      c(2)=1.0227e-4
      c(3)=-1.6546e-6
      d=4.8314e-4
      cval=(c(1)+(c(2)*t)+(c(3)*(t**2)))*(sqrt(s**3))
      d0=d*(s**2)
      sigma=(pw+bval+cval+d0)-1000
	RETURN
	END
c      
      REAL Z,TT,SS,FL,ltime,gtime,LATD,LATM,LOND,LONM
     &,BEGIN,TIME,LAT,LON
      DIMENSION IZ(10000), IT(10000), IS(10000)
      DIMENSION NSIGT(10000), IF(10000)
      CHARACTER FILENAME*60,INFILE*50,WHAT*1
     &,OUTFILE1*25,OUTF*15,OUTFILE2*25
     &,ICNS*3,SH*2,CNTRY*2,ISNS*3,CR*2,IBUFF*80
C
        INFILE='oc36.HDR'
	OUTF='check.DAT'
       OUTFILE1='oce9936.dat'
        outfile2='primary.h3'
      write(*,*) 'is gmt  +4  or  +5  hours for this cruise ? (4/5)'
       read(*,1) gGtime
  1    format(f3.0)
       WRITE(*,*)'DO YOU WANT TO MAKE AN OUTPUT NODC FILE ?'
       READ(*,2) WHAT
 2     FORMAT(A1)
	IF(WHAT .EQ. 'Y'.OR. WHAT .EQ. 'y')THEN
       OPEN (UNIT=9, FILE=OUTFILE1, STATUS='NEW', FORM='FORMATTED',
     +    ACCESS='SEQUENTIAL',MODE='WRITE')
	OPEN(UNIT=2,FILE=OUTF,ACCESS='SEQUENTIAL',FORM=
     +  'FORMATTED',STATUS='NEW',mode='write')
	 END IF
       open (unit=7, file=outfile2, status='new', form='formatted',
     +    access='sequential',mode='write')
C
	OPEN (UNIT=3, FILE=INFILE, STATUS='OLD', FORM='FORMATTED',
     +    ACCESS='SEQUENTIAL',MODE='READ')
 5        READ(3,6,END=12,ERR=70)IBUFF
 6        FORMAT(A80)
	 READ(IBUFF,7)cntry,sh,ilatD,ILATM,ilonD,ILONM,iyr,
     +   MO,iday,ihr,kmin,cr,icCns,ibtm,isns,nh
 7       FORMAT(a2,A2,t5,I2,I3,T11,I2,I3,T19,I2,T21,i2,T23,
     +   I2,T25,i2,T27,i1,t29,a2,t31,I3,t34,I4,t70,A3,t80,i1)
C
	READ(IBUFF,8)ILAT,ILON,TIME,ICNS
 8      FORMAT(T5,I5,T11,I5,T25,F3.1,T31,A3)
C        
	LATD=REAL(ILATD)
	LOND=REAL(ILOND)
	LATM=ILATM/10.0
	LONM=ILONM/10.0
C        WRITE(*,*)LATD,LATM,LOND,LONM
C
c write the jgof H2 (1 record for bscale cruises) and H3 files !!!
C
      if (mo .eq. 1) THEN
      begin = 0
      end if
      if (mo .eq. 2) THEN
      begin = 31
      end if
      if (mo .eq. 3) THEN
      begin = 59
      end if
      if (mo .eq. 4) THEN
      begin = 90
      end if
      if (mo .eq. 5) THEN
      begin = 120
      end if
      if (mo .eq. 6) THEN
      begin = 151
      end if
      if (mo .eq. 7) THEN
      begin = 181
      end if
      if (mo .eq. 8) THEN
      begin = 212
      end if
      if (mo .eq. 9) THEN
      begin = 243
      end if
      if (mo .eq. 10) THEN
      begin= 273
      end if
      if (mo .eq. 11) THEN
      begin= 304
      end if
      if (mo .eq. 12) THEN
      begin= 334
      end if
c
      if(TIME .le. GGTIME)then
      idy=iday-1
      TIM=(24.0+TIME)-gGtime
      ELSE IF(TIME .GT. Ggtime)THEN
      TIM=TIME-gGtime
      idy=iday
      end if
      if (TIME .EQ. 0.0)then
      gtime=begin+iday
      else if (TIME .NE. 0.0)then
      gtime=REAL(begin+iday+(TIME/24.0))     
      ltime=REAL(begin+idy+(TIM/24.0))
      end if
c
      lon=REAL(lond+(lonm/60.0))
      lat=REAL(latd+(latm/60.0))
      lon=lon*(-1.0)
c
c  FOR CRUISES BEFORE ALB9410, OUTPUT FILES ARE ASCII OUTPUT OF
C  MK5 SOFTWARE...THEY WILL BE .PRE (AND EVENTUALLY .PRS) FILES
C  FOR 1995-? BSCALE CRUISES.
C
      filename='oc36d'//icns//'.pre'
c
      WRITE(7,11)GTIME, LTIME, ICCNS,ibtm, LON, LAT, FILENAME
 11   FORMAT(F8.4,1X,F8.4,T20,I3,t33,i4,T38,F7.3,T48,F6.3,T55,A20)
C
 12     IF(WHAT .EQ. 'N')THEN
	GOTO 5
	END IF
C        
	WRITE(9,6)IBUFF
C
C

C*****FIND THE NBCTD .pre FILES !!!....PRE FILES ARE PRELIMINARY
C     .PRS FILES FROM PROGRAM MK5PROC.EXE   
C
C*****WILL PUT FLOUR IN COLUMN T60 I4 for now ??
C
C
      OPEN(UNIT=8,FILE=FILENAME,FORM='FORMATTED',STATUS='OLD'
     &,MODE='READ')
C
C*************  READING THE ".PRE" DATA FILES
C             NOTE 1/22/99 CHANGED FORMAT TO READ SB911 FILES
	KOUNT=1
	DTEST=.1
	DTEST=-DTEST
	ICOUNT=0
	I=0
	ZMAX=0.0
	IFLAGG=3
C        READ(8,20)
C 20     FORMAT(/,/,/,/,/,/,/,/,/,/,/,/,/)
C
 25       IF (ICCNS .GE. 100)THEN
        READ(8,31,END=55)Z,TT,SS,FL,B
        ELSE IF(ICCNS .LT. 100) THEN
        READ(8,31,END=55)Z,TT,SS,FL,b
        END IF
 30     FORMAT(T5,F5.1,T12,F7.4,T21,F7.4,t31,f6.4,T40,F3.0)
 31     FORMAT(T5,F7.3,T16,F7.4,T29,F7.4,T38,F5.3,T47,F9.4)
C
C       WRITE(*,*)Z,TT,SS,FL,B
C
	IF(NINT(Z).GT.0.0.AND.NINT(Z).GE.NINT(ZMAX))THEN
	IF(KOUNT .GE. 2 .AND. NINT(Z) .EQ. ZMAX)THEN
	GOTO 25
	END IF
	IT(KOUNT)=INT(TT*100)
	IS(KOUNT)=INT(SS*1000)
	IZ(KOUNT)=NINT(Z)
	IF(KOUNT)=INT(FL*1000)
	SIGN=SIGMA(TT,SS)
	IF(KOUNT .GE. 2)THEN
	DEL=SIGN-SIGO
	END IF
	IF (DEL .LT.DTEST)THEN
	WRITE(2,33)ICNS,IZ(KOUNT),DEL
 33     FORMAT(T10,A3,T17,I4,T25,F3.1)
	ICOUNT=ICOUNT+1
	END IF
c
c  **PUT IN HERE TO GET RID OF REPEATED DEPTHS
C
	IF(KOUNT .GE. 2 .AND. IS(KOUNT)-IS(KOUNT-1) .GE. 1000) THEN
	WRITE(*,35)ICNS,IZ(KOUNT-1),IS(KOUNT-1)
 35     FORMAT(/,' CHECK SALT! STA# ',A3,' DEPTH',I4,' SALT ',I5)
	END IF
	END IF
	NSIGT(KOUNT)=INT(SIGN*100)
C        IF (ICNS .EQ. 8) THEN
C        NSIGT(KOUNT)=9999
C        IS(KOUNT)=99999
C        END IF
 45     WRITE(9,50)IZ(KOUNT),IT(KOUNT),IS(KOUNT),
     C  NSIGT(KOUNT),IF(KOUNT),IFLAGG
 50     FORMAT(T28,I4,T33,I4,T38,I5,T43,I4,T60,I4,T80,I1)
	SIGO=SIGN
	ZMAX=IZ(KOUNT)
	KOUNT=KOUNT+1
	GOTO 25
C
  55    WRITE(*,56) FILENAME,KOUNT-1
  56    FORMAT('0',A50,' HAD ',I4,' RECORDS',/)
	IF (ICOUNT .GT. 0) THEN
	WRITE(2,60) ICNS,ICOUNT
	END IF 
C        WRITE(*,60) ICNS,ICOUNT
   60   FORMAT(/,'  STA #  ',A3,'  #CHKCTD RECORDS FLAGGED IS: ',I5,/)
	CLOSE(8)
	GO TO 5
C
C
  70    IF(WHAT .EQ. 'Y' .OR. WHAT .EQ. 'y')THEN
	WRITE (*,80) OUTFILE1
  80  FORMAT(10X,'1)  THE NODC FILE IS:',T56,A20)
	WRITE(*,81)OUTF
  81  FORMAT(10X,'2)  LOG OF CTD DENSITY CHECKING IS FOUND IN:',T56,A15)
	WRITE(*,82)OUTFILE2
  82  FORMAT(10X,'3)  JGOF HEADER FILE (.H3 ONLY) IS FOUND IN:',T56,A20)
	ELSE IF(WHAT .EQ. 'n' .OR. WHAT .EQ. 'N')THEN
	WRITE(*,83)OUTFILE2
 83   FORMAT(10X,'1)  JGOF HEADER FILE (.H3 ONLY) IS FOUND IN:',T56,A20)
	END IF
C
	if(what .eq. 'N' .or. what .eq. 'n')then  
	CLOSE(UNIT=7) 
	CLOSE(UNIT=3)
	elseif(what .ne. 'N' .or. what .ne. 'n')then
	CLOSE(2)
	CLOSE(7)
	close(9)
	close(3)
	end if
	STOP
	END
