% MATLAB routine to plot OAX output files

% define special paths
path(path,'/home3/ocn/jmanning/atsee');

ph=menu('What Phase?','plot stations',...
                       'spotchk results',...
                       'plot historical',...
                       'subplot obs & historical',...
                       'make flic',...
                       'plot search ellipses');
%ph=2;

if ph==1;

%  subplot(2,1,1);

% load original data by cruise 
  load /data5/jmanning/ctd/data/kat9502_II.data
  k=kat9502_II(find(diff(kat9502_II(:,3))>0),:);
  clear kat9502_II;
  load /data5/jmanning/ctd/data/sj9507.data
  s=sj9507(find(diff(sj9507(:,3))>0),:);
  clear sj9507;
  load /data5/jmanning/ctd/data/alb9505.data
  a=alb9505(find(diff(alb9505(:,3))>0),:);
  clear alb9505;
  georbat(1,0,0,2)
  axis([-69.5 -65. 40 42.5]);
  lllabel(30,30,40,42.5,-69,-65)
  corbw=menu('Colored or Black&White?','colored','b&w');
  if corbw==1; 
    plot(k(:,10),k(:,9),'.g','markersize',18)
    hold on;
    plot(s(:,10),s(:,9),'b.','markersize',18)
    plot(a(:,10),a(:,9),'.r','markersize',18);
    text(-67.5,40.3,'KAT9502_II 8-18 May, 1995','color','g','fontsize',10);
    text(-67.5,40.15,'SJ9507     8-14 May, 1995','color','b','fontsize',10);
    text(-67.5,40.0,'ALB9505    8-19 May, 1995','color','r','fontsize',10);
  else;
    plot(k(:,10),k(:,9),'w*','markersize',8)
    hold on;
    plot(s(:,10),s(:,9),'w.','markersize',18)
    plot(a(:,10),a(:,9),'wo','markersize',8);
    text(-67.5,40.25,'KAT9502_II 8-18 May, 1995','fontsize',12,'color','k');
    text(-67.5,40.10,'SJ9507     8-14 May, 1995','fontsize',12,'color','k');
    text(-67.5,39.95,'ALB9505    8-19 May, 1995','fontsize',12,'color','k');
  end;
  title('CTD Stations','fontsize',16)
%  legend('r.','Kat9502_II 8-18 May','g.','SJ9507 8-14 May','b.','ALB9505 9-18 May'); 
  if corbw==1;
    plot(-67.6,40.3,'g.','markersize',18)
    plot(-67.6,40.15,'b.','markersize',18)
    plot(-67.6,40.0,'r.','markersize',18);
  else;
    plot(-67.6,40.25,'w*','markersize',8)
    plot(-67.6,40.10,'w.','markersize',18)
    plot(-67.6,39.95,'wo','markersize',8);
  end;
%  set(gca,'xticklabels','');
%  xlabel(' ')

%  subplot(2,1,2);
%  cd /home3/ocn/jmanning/model/mfiles
%  movec
%  set(gca,'position',[0.1300    0.100    0.7750    0.3439])
%  orient tall;
end;
  



%%%%%%%%%%%%%%%%%%%%     spotchk results  %%%%%%%%%%%%%%%%%
if ph==2|ph==4;


% prompt for depth level(s) to look at
  lev=[0:10:60 75:25:150];
  wlev=menu('What level?',...
   num2str(lev(1)), num2str(lev(2)), num2str(lev(3)),...
   num2str(lev(4)), num2str(lev(5)),num2str(lev(6)),...
   num2str(lev(7)), num2str(lev(8)),num2str(lev(9)),...
   num2str(lev(10)),'bottom','all  levels');

% prompt for variable?
  wvar=menu('What variable?','temp','salt','sigmat','error');
%  wvar=3;

% load interpolated data
% call buildmat to load oax output data (load x,y,depth,variable)
% find this level in file

%   eval(['load /home3/ocn/jmanning/model/source/sline/may97wtf.',num2str(lev(wlev)),'m']);
   eval(['load /home3/ocn/jmanning/model/oax/standalone/oax/oce9936.',num2str(lev(wlev)),'m']);
%   eval(['load /home3/ocn/jmanning/model/source/sline/may97.',num2str(lev(wlev)),'m']);
   d=oce9936;
   if wvar==4;
%     dimensionalize this error
      stdod=std(od(ido,5));
      d(:,5)=stdod*d(:,5);
   end;
   x=d(:,1);y=d(:,2);z=d(:,wvar+2);
   hsec;
   hold on;

%  redefine wvar since hsec might change it
   wvar=2;

%next load original data & plot
  if wvar~=4;
    load /data5/jmanning/ctd/data/oce9936.data
    od=oce9936;
    if wlev<=10;
      ido=find(od(:,3)==lev(wlev));
    elseif wlev==11;
      ido=find(diff(od(:,3))<0);
    end;
    od=od(ido,:);
    plto=0;
    if plto==1;
      x=od(:,1);y=od(:,2);z=od(:,wvar+4);
      hsec;
    end;
  end;

% post interpolated data?
  pid=0;
  if pid==1;
    hold on;
    plot(d(:,1),d(:,2),'.');
    for k=1:10:length(d);
      text(d(k,1),d(k,2),num2str(d(k,4)),...
      'fontsize',6,'color','g')
    end;
  end;

%plot original points
  pod=1;
  if pod==1;
    hold on;
    wop=menu('What?','post points','post values');
    if wop==1;  
      plot(od(:,1),od(:,2),'c+');
    elseif wop==2;
      np=length(od);
      skip=input(['There are ',num2str(np),' points. Skip how many?']);
      for k=1:skip:np;
        text(od(k,1),od(k,2),num2str(od(k,wvar+4)),...
         'fontsize',6)
      end;
    end;
  end;

  hold on;


% basemap
%   georbat(2,0,1,0,0);
%   axis([-69 -65.5 40 42.5])
%   lllabel(60,60,40,42,-69,-65)
  title(['Observed Distribution at ',num2str(lev(wlev)),' meters ']);

% fix ticks to out
  set(gca,'TickDir','out')

% end phase 2
end;

%%%%%%%%%%%%%%%%%%%%%  Plot Historical Surfaces %%%%%%%%%%%%%%%%%%%%%%%%%

if ph==3|ph==4;


% load the nodal info for g2s
  load  /home3/ocn/jmanning/model/oax/history/g2s.nod         

% read the level surface dat from files out of gom/mass.fields at dartmouth
  wvar=menu('Which variable?','temp','salt','density');
  wvarc=['te';'sa';'st'];

  fih=fopen(['/home3/ocn/jmanning/model/oax/history/springa.l',wvarc(wvar,:)]);
  fscanf(fih,'%s',5)
% read the levels
  numl=fscanf(fih,'%f',1);
  for k=1:numl;
     dep(k)=fscanf(fih,'%f',1);
  end;

% one way to read is as follows:
  for l=1:6756;
    for j=1:numl;
      sa(l,j)=fscanf(fih,'%f',1);
    end;
  end;

%  alternative read is as follows
%  sa=fscanf(fih,'%f');
%  sa2=reshape(sa,6756,27);

% choose only the bank2 area
  idbx=find(g2s(:,2)>=166427&g2s(:,2)<=425954);
  idby=find(g2s(idbx,3)>=-237371&g2s(idbx,3)<=-18634);

% choose the particular depth level
  wdep=menu('What level?',...
  num2str(dep(1)), num2str(dep(2)), num2str(dep(3)),...
  num2str(dep(4)), num2str(dep(5)),num2str(dep(6)),...
  num2str(dep(7)), num2str(dep(8)),num2str(dep(9)),...
  num2str(dep(10)), num2str(dep(11)), num2str(dep(12)),...
  num2str(dep(13)), num2str(dep(14)),num2str(dep(15)),...
  num2str(dep(16)), num2str(dep(17)),num2str(dep(18)),...
  num2str(dep(19)), num2str(dep(20)), num2str(dep(21)),...
  num2str(dep(22)), num2str(dep(23)),num2str(dep(24)),...
  num2str(dep(25)), num2str(dep(26)),num2str(dep(27)),...
  'all  depths');

% extract only this depth from file

  
% generate a 25 by 25 regular grid of historical data
  [rgx,minx,maxx]=range(g2s(idbx(idby),2));
  [rgy,miny,maxy]=range(g2s(idbx(idby),3));
  xi=minx:rgx/25:maxx;
  yi=[miny:rgy/25:maxy]';
% interpolate data to this grid
  disp(' ')
  disp('Please hold on while contouring performed.')
  [zi]=griddata(g2s(idbx(idby),2),g2s(idbx(idby),3),sa(idbx(idby),wdep),xi,yi);



% output the xy grid coordinates and then convert xy to lat/lon
  fploopy([xi' yi],'xygrid.dat')
  disp('input xygrid.dat to lat/lon conversion');
  !/home3/ocn/jmanning/model/d3/ll2xy_xygrid.exe
  load out.dat
  fploopy(out,'llgrid.dat','o')


  if ph~=4; clf; end;

% in the case of ph==4, make a subplot
  subplot(2,1,2);
%  axis('off');
%  h=axes;
%  set(h,'aspectratio',[1 .78])


% choose an appropriate contour levels
  [rgv,minv,maxv]=range(d(id,wv))
    disp('choose contour level as v');
    keyboard;



  extcontour(out(:,1),out(:,2),zi,v,'label','fill');
  colormap(jet)
  hold on;

%automatic blanking using the bounds of bank150 (had to be generated at first)
   load /home3/ocn/jmanning/model/oax/inputfiles/bank150_ll.bln
   fill(bank150_ll(:,1),bank150_ll(:,2),'k')

% basemap
   georbat(2,0,1,0,0);
   axis('square');
   axis([-69 -65.5 40 42.5])
   lllabel(60,60,40,42,-69,-65)
  title(['Historical Distribution at ',num2str(dep(wdep)),' meters ']);

% manual blanking
  hold on;
  hmt=input('how many blking steps?');
  for k=1:hmt;
    disp('pick three points to clean up edges')
    [blx,bly]=ginput(3);
    blx=[blx; blx(1)];
    bly=[bly; bly(1)];
    fill(blx,bly,'k');
  end;

% fix ticks to out
  set(gca,'TickDir','out')
end;


%%%%%%%%%%%%%%%%%%%%%  Making Flic Movie %%%%%%%%%%%%%%%%%%%

if ph==5;

%load series of level files contouring each one

% define depth level(s) to look at
  lev=[0:10:60 75:25:150];



  wvar=menu('Which variable?','temp','salt','density');

% open a list file for image names
  cvar=['temp';'salt';'dens'];
  fid2=fopen(['list.',cvar(wvar,:),''''],'w');

% choose an appropriate contour levels
      disp('choosing hardcoded contour level as v');
  if cvar(wvar,:)=='temp';
      v=5:1:20;
  elseif cvar(wvar,:)=='salt';
      v=31:.5:36;
  elseif cvar(wvar,:)=='dens';
      v=24:.2:27;
  end;

% add 2 to wvar for skipping lat/lon coloumns
  wvar=wvar+2;


% get one of the levels to see where xy limits are
  load  /home3/ocn/jmanning/model/oax/finaloutput/midmay95.0m
  d=midmay95;

% generate a xx by yy regular grid of interpolated data
  [rgx,minx,maxx]=range(d(:,1));
  [rgy,miny,maxy]=range(d(:,2));
  xx=20;
  yy=20;
  xi=minx:rgx/xx:maxx;
  yi=[miny:rgy/yy:maxy]';
% output the xy grid coordinates and then convert xy to lat/lon
  fploopy([xi' yi],'xygrid.dat','o')
  disp('input xygrid.dat to lat/lon conversion');
  !/home3/ocn/jmanning/model/d3/ll2xy_xygrid.exe
  load out.dat
  fploopy(out,'llgrid.dat','o')

% interpolate bathymetry data to this grid
  disp(' ')
  disp('Please hold on while bathy gridding performed.')
% get bathy file
  load /home3/ocn/jmanning/model/oax/inputfiles/bank150.bat;
  bat=bank150;
  clear bank150;
  [zib]=griddata(d(:,1),d(:,2),bat(:,2),xi,yi);

% start loop through various layers
  for k=1:length(lev);
 
%   load file for this level
    eval(['load /home3/ocn/jmanning/model/oax/finaloutput/midmay95.',num2str(lev(k)),'m']);
    d=midmay95;
    clear midmay95;


% interpolate data to this grid
    disp(' ')
    disp('Please hold on while gridding performed.')
    [zi]=griddata(d(:,1),d(:,2),d(:,wvar),xi,yi);

% If the data is deeper than bathy set value to NaN
    for jj=1:xx;
      for kk=1:yy;
        if zib(jj,kk)<lev(k);
          zi(jj,kk)=NaN;
        end;
      end;
    end;


    hold off;
    clf;
    axis('off');
    h=axes;
    set(h,'aspectratio',[1 .78])

%contour
    extcontour(out(:,1),out(:,2),zi,v,'label','fill');
    colormap(jet)
    title([num2str(lev(k)),' meters ']);

    hold on;

%automatic blanking using the bounds of bank150
    load /home3/ocn/jmanning/model/oax/inputfiles/bank150_ll.bln
    fill(bank150_ll(:,1),bank150_ll(:,2),'k')

% basemap
    georbat(2,0,1,0,0);
    axis([-69 -65.5 40 42.5])
    lllabel(60,60,40,42,-69,-65)

% fix ticks to out
    set(gca,'TickDir','out')


    drawnow
% CAPTURE THIS IMAGE
    
    disp(' ');
    disp('Click Figure Window!!');
    eval(['!xwd -nobdrs  | imconv -xwd -infile - -gif -outfile ',num2str(k),'.gif']);
    !exit

% add to list file
    fprintf(fid2,'%s\n',[num2str(k),'.gif']);

% end of image loop, go get another one
  end;

  fclose(fid2)

% READY to generate the movie
  eval(['!/home3/ocn/jmanning/flic/xanim2703/fbm2fli list.',cvar(wvar-2,:),' flc.',cvar(wvar-2,:)]);
  
% Ready to view the movie
  eval(['!xanim flc.',cvar(wvar-2,:)]);
  
% end of phase 5 of spotchk.m
end;

%%%%%%%%%%%%%%%%%%%%%%%  plot search ellipses %%%%%%%%%%%%%%%%%
if ph==6;
  load /home3/ocn/jmanning/model/oax/intermediate/midmay95.grid

% find surface values
  g=midmay95;
  id=find(g(:,3)==0);
  
% plot every nth ellipse
  nth=100;

% try using arrow as Charles had?

%  for k=1:100:length(id);
%    arrow([g(id(k),1) g(id(k),2)],[g(id(k),1)+g(id(k),6) g(id(k),2)],'color','r')
%    arrow([g(id(k),1) g(id(k),2)],[g(id(k),1) g(id(k),2)+g(id(k),7)],'color','g')
%    hold on;
%  end;
%  that didn't work because we need to rotate

%  for k=1:100:length(id);
%    ellipse(g(id(k),1),g(id(k),2),max([g(id(k),6) g(id(k),7)])*100,min([g(id(k),6) g(id(k),7)])*100,-1*g(id(k),5),20,2)
%    hold on;
%  end;
%  that didn't work because ellipse is designed for lat/lon units

% try converting it to lat/lon
  yy=[g(id,1) g(id,2)];
  save this.dat yy -ascii
  !/home3/ocn/jmanning/model/d3/ll2xy_def.exe
  load out.dat
  
  for k=1:length(id);
    ellipse(out(k,1),out(k,2),g(id(k),6)/2000,g(id(k),7)/2000,-1*g(id(k),5),20,2)
    if k==1; axis([-70 -65 40 42]);    hold on; end;
%  plot(out(:,1),out(:,2),'g.','markersize',5);
  end;

  georbat;
  set(gca,'aspectratio',[1 .78])
  axis([-70 -65.5 40 42.5]);
  lllabel(60,60,40,42,-70,-66)

% add legend
  ellipse(-67.3,40,50,30,0,20,2);
  text(-67,40,'100 km (major axis)')
  title('Optimal Interpolation Search Ellipse = f(bathymetric gradient)')

  orient landscape

end;
    
